#include <lynx.h>
#include <lynxlib.h>
#include <global.h>
#include <joypad.h>

// have to have stuff before first //

// Choplifter for Lynx
// Jum Hig 2000

/* __ALWAYS__ use both defines but using is recommended for shorter code */
#define FIXARGC         /* be sure you don't use <8 arguments ! */
#define NOARGC

#define	BUFFER1	0x9000

/*************** for VSYNC handling*******************/
uchar frames, lines;

extern uchar VBLflag;
#asm
_VBLflag = $a0
#endasm

#define VSYNC {++VBLflag;while( VBLflag );}

/*************** sprites *****************************/
extern uchar SCB1[];
extern uchar SCB2[];
extern uchar SCB3[];
extern uchar SCB4[];
extern uchar SCB5[];
extern uchar SCB6[];
extern uchar SCB7[];
extern uchar SCB6b[];
extern uchar SCB7b[];
extern uchar SCB8[];
extern uchar SCB9[];
extern uchar SCB10[];
extern uchar SCBclr[];
extern uchar SCBp1[];					// heli

/*************** samples ****************************/
extern uchar starkick[];

#asm
		xref title
		xref t_chopr
		xref t_rotor1
		xref t_rotor2
		xref t_text
		xref hills
		xref mountain
		xref heli
		xref heli2
		xref heli3
		xref cloud2
		xref cloud4
		xref cloud5
		xref blade1
		xref blade2
		xref blade3

_SCBclr	dc.b $c1,$10,$20
		dc.w _SCB6,_sprclr
		dc.w $100,0,$a000,$6600
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef

_sprclr	dc.b $03, $08, $00, $00

_SCB1	dc.b $c1,$10,$20
		dc.w _SCB2,title
		dc.w 0,0,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef

_SCB2	dc.b $c5,$18,$20
		dc.w _SCB3,t_chopr
		dc.w 47,102,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef

_SCB3	dc.b $c5,$14,$20
		dc.w _SCB4,t_rotor1
		dc.w 29,102,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef

_SCB4	dc.b $c5,$14,$20
		dc.w _SCB5,t_rotor2
		dc.w 29,102,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef

_SCB5	dc.b $c5,$18,$20
		dc.w 0,t_text
		dc.w 1,90,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef

_SCB6	dc.b $c1,$10,$20
		dc.w _SCB6b,mountain
		dc.w 0,77,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef

_SCB6b	dc.b $c1,$10,$20
		dc.w _SCB7, mountain
		dc.w 0,77,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef

_SCB7	dc.b $c5,$18,$20
		dc.w _SCB7b, hills
		dc.w $100,83,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef

_SCB7b	dc.b $c5,$18,$20
		dc.w _SCBp1, hills
		dc.w 0,83,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef

_SCB8	dc.b $c1,$18,$20
		dc.w _SCB9, cloud2
		dc.w $120,10,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef

_SCB9	dc.b $c1,$18,$20
		dc.w _SCB10, cloud4
		dc.w $140,30,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef

_SCB10	dc.b $c1,$18,$20
		dc.w 0, cloud5
		dc.w $160,44,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef

_SCBp1	dc.b $c4,$38,$20						// no collide, vstretch
		dc.w 0, blade3
		dc.w $140,32,$100,$100
		dc.w $010, $200
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef

#endasm

#include "work.pal"				// work palette
#include "title.pal"			// pal for title screen
#include "cliftpal.pal"			// main game pal
#include "bgcol.pal"			// bg colours for every line (HBL)

;

// checkerboard fade
void fade_checker(void) {
	uchar *i;
	int j;
	int k;
	i = ScreenBuffer;
	
	for(j=0; j<4; j++) {
		for(k=0; k < 8160; k += 4) {
			*(i+k+j) = 0;
		}
	}
}

// reset work pal to black
void reset_workpal(void) {
	uchar x;
	for(x=0; x<32; x++) workpal[x] = 0x00;
}

// fade work palette to
void fade_in(void) {
	uchar x, y, c, d;
	
	// fade in to required palette
	for(y=0; y<16; y++) {
		for(x=0; x<16 ; x++) {
			if(workpal[x] < pal[x]) workpal[x]++;
			d = c = workpal[x+16];
			c &= 0xF0;
			d &= 0x0F;
			if(c < (pal[x+16] & 0xF0)) c += 0x10;
			if(d < (pal[x+16] & 0x0F)) d += 0x01;
			workpal[x+16] = c+d;
		}
		VSYNC; VSYNC;
		_SetRGB(workpal);
	}
}

// fade out palette
void fade_out(void) {
	uchar x, y, c, d;

	// copy pal to workpal
	for(x=0; x<32; x++) {
		workpal[x] = pal[x];
	}
	
	// fade out palette
	for(y=15; y ; y--) {
		for(x=0; x<16 ; x++) {
			if(workpal[x]) workpal[x]--;
			d = c = workpal[x+16];
			c &= 0xF0;
			d &= 0x0F;
			if(c) c -= 0x10;
			if(d) d -= 0x01;
			workpal[x+16] = c+d;
		}
		VSYNC; VSYNC;
		_SetRGB(workpal);
	}
}

// read joystick
uchar joypad(void)
{
	return PEEK(0xFCB0);
}

// Vertical "blank" interrupt routine
VBL() interrupt
{
	lines = VBLflag = 0; /* indicates that a VBL has ocurred */
	frames++;
}

// Horizontal "blank" interrupt routine
// note: get cycle count!
HBL() interrupt
{
#asm

ch_clr	pha
		phx
		ldx	_lines
		inc _lines
		inc _lines
		lda _bgcol,x
		sta	$FDA0
		lda _bgcol+1,x
		sta $FDB0
		plx
		pla
#endasm
}

// ******************** MAIN *************************
main() {
	zstatic char t1, heli_dx, heli_dy;
	zstatic uint heli_x, heli_y;

	uchar x,y,c,d,j;
	uint hill1x, hill2x, mntn1x, mntn2x, bg_x;
	
	InitIRQ();
	InstallIRQ(2,VBL);
	InstallIRQ(0,HBL);
	EnableIRQ(2); /* 42BS */
	//EnableIRQ(0);
	CLI;
	frames = 0;

	SetBuffers(BUFFER1,0,0);

	// reset palette
	reset_workpal();
	_SetRGB(workpal);
	VSYNC;
	DrawSprite(SCB1);
	
	// fade in screen
	fade_in();

	// debug - goto start
	goto start;
	
	// display title screen while moving copter up the screen
	x = 120;
	while(x != 30) {
  		SCB2[9] = x;
  		SCB3[9] = x - 4;
  		SCB4[9] = x - 4;
  		y = x % 2;
  		if(y) { SCB3[1] = 0x18 ; SCB4[1] = 0x14; }
  		else { SCB3[1] = 0x14 ; SCB4[1] = 0x18; }
   		VSYNC;
  		DrawSprite(SCB1);
  		x--;
	};

	// wait for A or B button to start
	// keep rotors rotating
	while((joystick & 0x03) == 0) {
  		y = x % 2;
		if(y) { SCB3[1] = 0x18 ; SCB4[1] = 0x14; }
		else { SCB3[1] = 0x14 ; SCB4[1] = 0x18; }
		VSYNC;
		DrawSprite(SCB1);
		x--;
	}

	// fade screen out checkerboard effect
	//fade_checker();

	// fade out palette
	fade_out();

start:
	//SmpInit(0,1);				// channel 0, timer 1
	//EnableIRQ(1);    /* use a macro defined in lynxlib.h */
	//SmpStart(starkick, 20);

	// set H_OFF for sprites to 256
	asm(" pha\n"\
		" lda #$01\n"\
		" sta $FC05\n"\
		" pla");

	_SetRGB(cliftpal);
	EnableIRQ(0);

	hill1x = 0x100; hill2x = 0x200;
	mntn1x = 0x100; mntn2x = 0x200;


// all sprite coordinates in 10:6 fixed pt.
// for smooth-scrolling background etc.
	heli_y = 32 << 6; heli_x = 200 << 6;
	heli_dy = 0; heli_dx = 0;
	
	while(1) {
		// move background
		bg_x = heli_x >> 7;
		hill1x = (0x4000 - bg_x) & 0x1ff;				// ASM these !
		hill2x = (0x4100 - bg_x) & 0x1ff;
		bg_x = bg_x >> 1;
		mntn1x = (0x4000 - bg_x) & 0x1ff;
		mntn2x = (0x4100 - bg_x) & 0x1ff;
		//VSYNC;
		SCB6[7] = mntn1x & 0xFF;
		SCB6[8] = mntn1x >> 8;
		SCB7[7] = hill1x & 0xFF;
		SCB7[8] = hill1x >> 8;
		SCB6b[7] = mntn2x & 0xFF;
		SCB6b[8] = mntn2x >> 8;
		SCB7b[7] = hill2x & 0xFF;
		SCB7b[8] = hill2x >> 8;
		
		SCB8[7] -= 7;
		SCB9[7] -= 5;
		SCB10[7] -= 3;

		// move chopper
		j = joystick;
		if(j & JOY_UP) heli_dy--;
		else if(j & JOY_DOWN) heli_dy++;
		heli_y += heli_dy;
		d = heli_y >> 6;
		if(d < 13) heli_dy = 0;
		else if(d > 84) { heli_dy = 0; heli_dx = 0; } 
		SCBp1[9] = d;
		if(j & JOY_RIGHT) { if(heli_dx != 64) heli_dx++; }
		else if(j & JOY_LEFT) { if(heli_dx != -64) heli_dx--; }
		heli_x += heli_dx;
		d= 80 - heli_dx;
		SCBp1[7] = d;
		VSYNC;
		 
		DrawSprite(SCBclr);
	}
	
  for(;;);

}
